"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const openai_1 = require("openai");
const React = __importStar(require("react"));
const use_deep_compare_1 = require("use-deep-compare");
function useCompletion({ apiKey, ...maybeRequest }) {
    const request = (0, use_deep_compare_1.useDeepCompareMemo)(() => maybeRequest, [maybeRequest]);
    const shouldSkip = typeof request.prompt !== 'string' || !request.prompt.length;
    const [state, setState] = React.useState({
        completion: null,
        loading: !shouldSkip,
    });
    React.useEffect(() => void (async () => {
        if (shouldSkip)
            return;
        setState(e => ({ ...e, loading: true, error: undefined }));
        try {
            const openai = new openai_1.OpenAIApi(new openai_1.Configuration({ apiKey }));
            const { data: completion } = await openai.createCompletion(request);
            setState(state => ({ ...state, loading: false, completion }));
        }
        catch (error) {
            setState(state => ({
                ...state,
                loading: false,
                // @ts-expect-error axios-style errors
                error: new Error(String(error?.response?.data || error?.message || error)),
            }));
        }
    })(), [request, shouldSkip, apiKey]);
    return state;
}
exports.default = useCompletion;
